/*  --- Copyright University of Sussex 1992. All rights reserved. ----------
 >  File:           C.all/lib/ved/ved_showinclude.p
 >  Purpose:        for examining library files
 >  Author:         Aaron Sloman (Sept 1990) (see revisions)
 >  Documentation:	REF * VED_SHOWINCLUDE, * INCLUDE, REF *POPINCLUDELIST,
					HELP * INCLUDE HELP *SHOWLIB,  REF * LIBRARY
 >  Related Files:	LIB * INCLUDE , * POPINCLUDELIST
 */

section;

define global ved_showinclude();
	vedsetup();
	if vedargument /= nullstring
	and sys_fname_extn(vedargument) = nullstring
	then
		;;; Add explicit include-file extension
		;;; Use '.ph' if filename is all lower or mixed case, '.PH' otherwise
		;;; 	(because of case-conversion done subsequently by vedsysfile)
		lvars char, extn = '.PH';
		for char in_string vedargument do
			if islowercode(char) then
				'.ph' -> extn;
				quitloop
			endif
		endfor;
		vedargument <> extn -> vedargument
	endif;
	vedsysfile("vedlibname",
				popincludelist,
				procedure();
					"include" -> vedfileprops;
					vedhelpdefaults();
				endprocedure);
enddefine;

"ved_showinclude" -> vedgetsysfilepdr("INCLUDE");

endsection;

/* --- Revision History ---------------------------------------------------
--- John Williams, Sep 14 1992
		Now adds '.ph' in uppercase if passed an all uppercase file name
--- Robert John Duncan, Feb 10 1992
		Removed dlocal of -pop_default_type- which doesn't get undone if
		this is used as the entry point to ved. Added an explicit '.ph'
		extension to the argument instead.
--- John Gibson, Oct 31 1990
		Moved -showinclude- to where it should have been, i.e. in
		$popautolib
 */
