/* --- Copyright University of Sussex 1995. All rights reserved. ----------
 > File:            C.all/lisp/flib/fbuffer.p
 > Purpose:         Utilities for LIB * FORMAT_PRINT
 > Author:          John Williams, Nov  2 1994 (see revisions)
 > Documentation:
 > Related Files:   LIB * FORMAT_PRINT
 */


section $-lisp$-fpr;

/* Utilities for determining the printed length of an item, and
	saving the printed representation in a string.

	Cannot simply set cucharout to identfn and count the stack length
	as this would confuse Lisp.
*/


global vars
	fbuffer         =   inits(128),
	fbuffer_i       =   0,
	fbuffer_len     =   128,
	;


define fbuffer_charout(c);
	lvars b;
	unless isinteger(c) do
		chain(c, fbuffer_charout, appdata)
	endunless;
	if fbuffer_i fi_>= fbuffer_len then
		inits(fbuffer_len fi_+ 128) -> b;
		move_bytes(1, fbuffer, 1, b, fbuffer_len);
		b -> fbuffer;
		datalength(fbuffer) -> fbuffer_len
	endif;
	c -> fast_subscrs(fbuffer_i fi_+ 1 ->> fbuffer_i, fbuffer)
enddefine;


define fprint_to_string(item);
	lvars i = fbuffer_i;
	dlocal fbuffer_i, cucharout = fbuffer_charout;

	define dlocal cucharout(c);
		lvars c, b;
		if fbuffer_i fi_>= fbuffer_len then
			inits(fbuffer_len fi_+ 128) -> b;
			move_bytes(1, fbuffer, 1, b, fbuffer_len);
			b -> fbuffer;
			datalength(fbuffer) -> fbuffer_len
		endif;
		c -> fast_subscrs(fbuffer_i fi_+ 1 ->> fbuffer_i, fbuffer)
	enddefine;

	pr(item);
	substring(i fi_+ 1, fbuffer_i fi_- i, fbuffer);     /* printed form */
	fbuffer_i fi_- i                                    /* length */
enddefine;


endsection;


/* --- Revision History ---------------------------------------------------
--- John Williams, Aug 23 1995
		Removed redundant lvar declarations.
 */
